\name{bg.adjust.gcrma}
\alias{bg.adjust.gcrma}
\alias{bg.parameters}
\title{Background ajustment with sequence information (internal function)}
\description{
An internal function to be used by \code{\link{bg.correct.gcrma}}.
}
\usage{
bg.adjust.gcrma(Data, gcgroup, estimate = c("eb", "mle"), rho = 0.8, 
    step = 60, lower.bound = 1, baseline = 0.25,triple.goal, ...) 
%bg.parameters(pm, n.pts = 2^14)
}
\arguments{
  \item{Data}{matrix of 2 columns, column 1: pm intensities,column 2: mm intensities.}
  \item{gcgroup}{A list of indexes indicating G,C strata.}
  \item{estimate}{method of background correction, "eb" for empirical Bayes, "mle" for maximum likelihood} 
   \item{rho}{correlation coefficient of log background intensity in a pair of pm/mm probes. Default=.8.}
  \item{baseline}{For estimate="mle" only. The lowest log(expression) value allowed. Default=.25}
  \item{lower.bound}{For estimate="eb" only. Lower bound of signal intensity allowed a priori. Default=1.}
   \item{triple.goal} {logical value. If \code{TRUE} Shen and Louis'
    triple-goal adjustment is used.}
   
  \item{step}{a parameter in approximating "eb" estimates.}
  \item{...}{extra arguments to pass to bg.adjust.}

}
\details{ Assumes PM=background1+signal,mm=background2, (log(background1),log(background2))'
follow bivariate normal distribution, signal distribution follows power law.
\code{bg.parameters.gcrma} and \code{sg.parameters.gcrma}
provide adhoc estimates of the parameters.}
\value{a vector of length nrow(Data).}
\seealso{\code{\link{bg.correct.gcrma}}}
\author{Jean Wu, Rafeal Irizarry}
\keyword{manip}% at least one, from doc/KEYWORDS

