\name{bg.correct.gcrma}
\alias{bg.correct.gcrma}
\title{Background Correction Using sequence information}
\description{
Background corrects probe intensities in an object of class
\code{\link[affy:AffyBatch-class]{AffyBatch}}.
}
\usage{
bg.correct.gcrma(object,gcgroup=getGroupInfo(Dilution)),...)
}

\arguments{
  \item{object}{An object of class \code{\link[affy:AffyBatch-class]{AffyBatch}}.}
  \item{gcgroup}{A list of indexes indicating G,C strata.}
  \item{...}{estimate:method of background correction, "eb" for empirical Bayes, "mle" for maximum likelihood. 

rho:correlation coefficient of log background intensity in a pair of pm/mm probes. Default=.8.

baseline:For estimate="mle" only. The lowest log(expression) value allowed. Default=.25

lower.bound:For estimate="eb" only. Lower bound of signal intensity allowed a priori. Default=1.
}}
\details{Assumes PM=background1+signal,mm=background2, (log(background1),log(background2))'
follow bivariate normal distribution, signal distribution follows power law.
\code{bg.parameters.gcrma} and \code{sg.parameters.gcrma} provide
 adhoc estimates of the parameters.}

\value{
  An \code{\link[affy:AffyBatch-class]{AffyBatch}} for which the PM
  intensities have been background adjusted and MMs remain the
  same. 
}

\examples{
 require(affydata)
data(Dilution)
Dil.adj<-bg.correct.gcrma(Dilution,gcgroup=getGroupInfo(Dilution),estimate="mle")}
\author{Jean Wu, Rafeal Irizarry}
\keyword{manip}% at least one, from doc/KEYWORDS
